#!/usr/bin/perl
# author: Fuyuncat
# Site:   WWW.HelloDBA.COM
# Script: http://www.Hellodba.com/Download/cal_height_balanced_dens.zip
#
#    Calculate the densitiy with Height Balanced Histogram, including the checking.

use POSIX;

sub round {
    my($number) = shift;
    return int($number + .5);
}

sub scale_check {
    local($sdiv) = $sndv/$snnv;
    local($q) = $pct/100;
    local($th) = 0.1*$q;

    if (!defined($sdiv) || $snnv<100 ||
        ($q < 0.001 &&
         (($snnv >= 100 && $snnv < 500 && $sdiv > 0.3220) ||
          ($snnv >= 500 && $snnv < 1000 && $sdiv > 0.4964) || 
          ($snnv >= 1000 && $snnv < 2000 && $sdiv > 0.5815) || 
          ($snnv >= 2000 && $snnv < 5000 && $sdiv > 0.6633) || 
          ($snnv >= 5000 && $snnv < 10000 && $sdiv > 0.7583) || 
          ($snnv >= 10000 && $snnv < 1000000 && $sdiv > 0.8168) || 
          ($snnv >= 1000000 && $sdiv > 0.9784))) ||
        (($q >= 0.001 && $q < 0.01) &&
         (($snnv >= 100 && $snnv < 500 && $sdiv > 0.3220) ||
          ($snnv >= 500 && $snnv < 1000 && $sdiv > 0.4974) || 
          ($snnv >= 1000 && $snnv < 2000 && $sdiv > 0.5820) || 
          ($snnv >= 2000 && $snnv < 5000 && $sdiv > 0.6638) || 
          ($snnv >= 5000 && $snnv < 10000 && $sdiv > 0.7587) || 
          ($snnv >= 10000 && $snnv < 1000000 && $sdiv > 0.8173) || 
          ($snnv >= 1000000 && $sdiv > 0.9789))) ||
        (($q >= 0.01 && $q < 0.1) &&
         (($snnv >= 100 && $snnv < 500 && $sdiv > 0.3223) ||
          ($snnv >= 500 && $snnv < 1000 && $sdiv > 0.5003) || 
          ($snnv >= 1000 && $snnv < 2000 && $sdiv > 0.5850) || 
          ($snnv >= 2000 && $snnv < 5000 && $sdiv > 0.6673) || 
          ($snnv >= 5000 && $snnv < 10000 && $sdiv > 0.7625) || 
          ($snnv >= 10000 && $snnv < 1000000 && $sdiv > 0.8213) || 
          ($snnv >= 1000000 && $sdiv > 0.9834))) ||
        (($q >= 0.1 && $q < 0.15) &&
         (($snnv >= 100 && $snnv < 500 && $sdiv > 0.3485) ||
          ($snnv >= 500 && $snnv < 1000 && $sdiv > 0.5300) || 
          ($snnv >= 1000 && $snnv < 2000 && $sdiv > 0.6195) || 
          ($snnv >= 2000 && $snnv < 5000 && $sdiv > 0.7051) || 
          ($snnv >= 5000 && $snnv < 10000 && $sdiv > 0.8040) || 
          ($snnv >= 10000 && $snnv < 1000000 && $sdiv > 0.8648) || 
          ($snnv >= 1000000 && $sdiv > 0.9863))) ||
        (($q >= 0.15 && $q < 0.2) &&
         (($snnv >= 100 && $snnv < 500 && $sdiv > 0.3580) ||
          ($snnv >= 500 && $snnv < 1000 && $sdiv > 0.5492) || 
          ($snnv >= 1000 && $snnv < 2000 && $sdiv > 0.6405) || 
          ($snnv >= 2000 && $snnv < 5000 && $sdiv > 0.7285) || 
          ($snnv >= 5000 && $snnv < 10000 && $sdiv > 0.8295) || 
          ($snnv >= 10000 && $snnv < 1000000 && $sdiv > 0.8915) || 
          ($snnv >= 1000000 && $sdiv > 0.9891))) ||
        ($q >= 0.2 &&
         (($snnv >= 100 && $snnv < 500 && $sdiv > 0.3676) ||
          ($snnv >= 500 && $snnv < 1000 && $sdiv > 0.5689) || 
          ($snnv >= 1000 && $snnv < 2000 && $sdiv > 0.6638) || 
          ($snnv >= 2000 && $snnv < 5000 && $sdiv > 0.7538) || 
          ($snnv >= 5000 && $snnv < 10000 && $sdiv > 0.8572) || 
          ($snnv >= 10000 && $snnv < 1000000 && $sdiv > 0.9205) || 
          ($snnv >= 1000000 && $sdiv > 0.9947))) 
       ) 
    {
        if (abs($snnv - $sndv) <= $snnv*$th &&
            (($snnv >= 1896609 && $q >= 0.002894) ||
             ($nnv < 10000 && $snnv >= 1065) ||
             ($nnv < 40000 && $snnv >= 2776) ||
             ($nnv < 160000 && $snnv >= 7150) ||
             ($nnv < 640000 && $snnv >= 18268) ||
             ($nnv < 2560000 && $snnv >= 46442) ||
             ($nnv < 5120000 && $snnv >= 73953) ||
             ($nnv < 10240000 && $snnv >= 117686) ||
             ($nnv < 20480000 && $snnv >= 187185) ||
             ($nnv < 40960000 && $snnv >= 297606) ||
             ($nnv < 81920000 && $snnv >= 473011) ||
             ($nnv < 163840000 && $snnv >= 751605) ||
             ($nnv < 327680000 && $snnv >= 1194040)
           )) 
        {
            return 2;
        }
        else
        {
            return 0;
        }
    }
    else
    {
        return 1;
    }
}

sub kkesdv_scale {
    local($x);
    local($x1) = $sndv;
    local($x2) = $nnv;
    local($y2);
    local($z) = 1-$snnv/$nnv;
    $loop = 1;

    while ($loop == 1 && $x1 <= $x2) {
        $x = floor(($x1+$x2)/2);
        $y2 = $x*(1-$z**($nnv/$x));
        if ($y2 > $sndv) 
        {
            $x2 = $x-1;
        }
        elsif ($y2 < $sndv)
        {
            $x1 = $x + 1;
        }
        else
        {
            $loop = 0;
        }
    }
    $x;
}

# input data
# sample:
# ssize = 5401, popcnt = 0, ssizesq = 83601, popcntsq = 0, pct = 14.7058823529
# ssize = 5401, popcnt = 0, ssizesq = 82477, popcntsq = 0
# ssize = 5401, popcnt = 0, ssizesq = 83579, popcntsq = 0
# ssize = 1000, popcnt = 0, ssizesq = 100000, popcntsq = 0, pct = 50
$ssize = 5401; #sample size, sum the buckets size;
$ssizesq = 83601; #sequal sum of buckets sample size;
$popcnt = 0; #records number of popular values
$popcntsq = 0; #sequal sum of records number of popular values
$pct = 14.7058823529; #sample percent
print "ssize: $ssize; ssizesq: $ssizesq; popcnt: $popcnt; popcntsq: $popcntsq; pct: $pct\n";
if ($pct <= 0 ) {
    print "invalid PCT\n";
    exit;
}

#variables
$sndv = $ssize*(($ssize-$popcnt)/($ssizesq-$popcntsq)); #sample number of distinct values
$snnv = $ssize; # sample number of not null values;
$nnv = $ssize*100/$pct; # estimated number of not null values
print "sndv: $sndv; snnv: $snnv; nnv: $nnv\n";
if ($pct < 100) {
    $method = scale_check();
    if ($method == 1)
    {
        $den = 1/kkesdv_scale();
        print "kksesdv scaling, density=$den\n";
    }
    elsif ($method == 2)
    {
        $den = 1/($sndv*100/$pct);
        print "linear scaling, density=$den\n";
    }
    else
    {
        $den = $pct/($ssize*200);
        print "trying frequency formula, density=$den\n";
    }
}
else
{
    $den = 1/$sndv;
    print "Not sample, density=$den\n";
}

